//---------------------------------------------------------------------------
// Lethal Enforcers 2
// 
// Level        Saloon
// Round        5
// Background   568, 240
// SetScale     0x2f=3665, 0x03=5570
// Layers       255 49 48 47 47   46 30 30 30 30   29 7 5 3 0
//---------------------------------------------------------------------------
// Sprites	Enemy Sets
// 		1   2   3   
// BGJACK	X   X   X   
// BGMEXK	X   X   X   
// BGMEXS	X   X   X   
// BGMIKE	X   X   X   
// BGSTEV	X   X   X   
// BGTHIN	X   X   X   
// BWANGE	        X   
// GMRICH	X   X       
// GMSHEL	X           
//---------------------------------------------------------------------------

// Define hit points
define BGJACK_hp    2
define BGMEXK_hp    2
define BGMEXS_hp    2
define BGMIKE_hp    2
define BGSTEV_hp    2
define BGTHIN_hp    2
define BWANGE_hp    1
define GMRICH_hp    1
define GMSHEL_hp    1

// Define character literals
define BGJACK1      0
define BGJACK2      1
define BGJACK3      2
define BGJACK4      3
define BGJACK5      4
define BGJACK6      5
define BGJACK7      6
define BGJACK8      7
define BGJACK9      8
define BGJACK10     9
define BGMEXK1      10
define BGMEXK2      11
define BGMEXK3      12
define BGMEXK4      13
define BGMEXK5      14
define BGMEXK6      15
define BGMEXS1      16
define BGMEXS2      17
define BGMEXS3      18
define BGMEXS4      19
define BGMEXS5      20
define BGMEXS6      21
define BGMEXS7      22
define BGMEXS8      23
define BGMIKE1      24
define BGMIKE2      25
define BGMIKE3      26
define BGMIKE4      27
define BGMIKE5      28
define BGMIKE6      29
define BGMIKE7      30
define BGMIKE8      31
define BGSTEV1      32
define BGSTEV2      33
define BGSTEV3      34
define BGSTEV4      35
define BGSTEV5      36
define BGSTEV6      37
define BGSTEV7      38
define BGSTEV8      39
define BGSTEV9      40
define BGTHIN1      41
define BGTHIN2      42
define BGTHIN3      43
define BGTHIN4      44
define BGTHIN5      45
define BGTHIN6      46
define BGTHIN7      47
define BGTHIN8      48
define BGTHIN9      49
define BWANGE1      50
define GMRICH1      51
define GMRICH2      52
define GMSHEL1      53
define TROUGH       54
define SIGN         55
define LAMP1        56
define LAMP2        57
define LAMP1b       58
define LAMP2b       59
define PANE1        60
define PANE2        61
define PANE3        62
define PANE4        63
define PANE5        64
define PANE6        65
define PANE7        66
define PANE8        67
define CAL50        68
define TWIN         69
define KNIFE1       70
define KNIFE2       71
define KNIFE3       72
define KNIFE4       73
define KNIFE5       74
define KNIFE6       75
	
	
// Define difficulty levels
define L1           0
define L2           1
define L3           2
define L4           3
define L5           4
define L6           5
define L7           6
define L8           7

// Define object characteristics
define ENEMY        0x0001    // Enemy
define VICTIM       0x0002    // Victim
define DISAPPEAR    0x0004    // Disappear when out of screen
define GUN          0x0008    // Gun (red contour)
define FALL         0x0010    // Fall, so check for collision
define WINDOW       0x0020    // Window (translucent)
define THROWN       0x0040    // Thrown object (zoom)
define START_ANIM   0x0080    // Can start another anim. over actual one
define ARROW        0x0100    // Arrow (do an arc)
define BLINK        0x0200    // Blink at the end
define SCROLL       0x0400    // We can scroll even though he's not dead
define BOSS         0x0800    // Boss
define VEH_SINUSOID 0x1000    // Vehicle (sinusoidal movement)
define VEH_LINEAR   0x2000    // Vehicle (linear movement)
define NOKILL       0x4000    // Can't be killed
define NODISPLAY    0x8000    // Don't display
	
// Define positions
// p01 (side, run from left deck)
define p01_x        -25
define p01_y        155
define p01_l        6
define p01_scale    4401

// p02 (side, run from left)
define p02_x        -40
define p02_y        190
define p02_l        13
define p02_scale    5570

// p03 (side from window #1 left)
define p03_x        65
define p03_y        150
define p03_l        2
define p03_scale    3622

// p04 (side from window #1 right)
define p04_x        195
define p04_y        140
define p04_l        2
define p04_scale    3622

// p05 (side from entrance left)
define p05_x        220
define p05_y        140
define p05_l        3
define p05_scale    3665

// p10 (side from left)
define p10_x        90
define p10_y        185
define p10_l        12
define p10_scale    5483

// p11 (side from right)
define p11_x        470
define p11_y        160
define p11_l        11
define p11_scale    5397

// p12 (side from left deck)
define p12_x        122
define p12_y        160
define p12_l        6
define p12_scale    4401

// p13 (side from right deck)
define p13_x        465
define p13_y        160
define p13_l        6
define p13_scale    4401

// p13_1 (for bge roll)
define p13_1_x      490
define p13_1_y      165
define p13_1_l      6
define p13_1_scale  4401

// p14 (side from window #2 left)
define p14_x        380
define p14_y        150
define p14_l        2
define p14_scale    3622

// p15 (side from entrance right)
define p15_x        345
define p15_y        140
define p15_l        1
define p15_scale    3578

// p20 (side from window #2 right)
define p20_x        510
define p20_y        160
define p20_l        2
define p20_scale    3622

// p21 (side from right deck)
define p21_x        600
define p21_y        160
define p21_l        6
define p21_scale    4401

// p22 (side from right)
define p22_x        580
define p22_y        165
define p22_l        12
define p22_scale    5483


// Load backgrounds and sounds
LoadBKD \BACKGRND\LE2\SALOON\SALOON5.BKD
SetBKDLoc 0 -128 0 0
LoadVAB \SOUNDFX\LE2\SALOON.VAB

// Load characters
LoadKRT \SPRITES\LE2\SALOON\S1\BGJACK.KRT     // Ch 0 - BGJACK1
SetScale BGJACK1 p13_scale
SetTotalHitPoints BGJACK1 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 1 - BGJACK2   
SetScale BGJACK2 p05_scale
SetTotalHitPoints BGJACK2 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 2 - BGJACK3   
SetScale BGJACK3 p11_scale
SetTotalHitPoints BGJACK3 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 3 - BGJACK4   
SetScale BGJACK4 p12_scale
SetTotalHitPoints BGJACK4 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 4 - BGJACK5   
SetScale BGJACK5 p03_scale
SetTotalHitPoints BGJACK5 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 5 - BGJACK6   
SetScale BGJACK6 p02_scale
SetTotalHitPoints BGJACK6 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 6 - BGJACK7   
SetScale BGJACK7 p01_scale
SetTotalHitPoints BGJACK7 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 7 - BGJACK8   
SetScale BGJACK8 p15_scale
SetTotalHitPoints BGJACK8 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 8 - BGJACK9   
SetScale BGJACK9 p22_scale
SetTotalHitPoints BGJACK9 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 9 - BGJACK10  
SetScale BGJACK10 p20_scale
SetTotalHitPoints BGJACK10 BGJACK_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BGMEXK.KRT     // Ch 10 - BGMEXK1
SetScale BGMEXK1 p13_scale
SetTotalHitPoints BGMEXK1 BGMEXK_hp

CloneCharacter BGMEXK1                            // Ch 11 - BGMEXK2  
SetScale BGMEXK2 p10_scale
SetTotalHitPoints BGMEXK2 BGMEXK_hp

CloneCharacter BGMEXK1                            // Ch 12 - BGMEXK3  
SetScale BGMEXK3 p03_scale
SetTotalHitPoints BGMEXK3 BGMEXK_hp

CloneCharacter BGMEXK1                            // Ch 13 - BGMEXK4  
SetScale BGMEXK4 p04_scale
SetTotalHitPoints BGMEXK4 BGMEXK_hp

CloneCharacter BGMEXK1                            // Ch 14 - BGMEXK5  
SetScale BGMEXK5 p20_scale
SetTotalHitPoints BGMEXK5 BGMEXK_hp

CloneCharacter BGMEXK1                            // Ch 15 - BGMEXK6  
SetScale BGMEXK6 p22_scale
SetTotalHitPoints BGMEXK6 BGMEXK_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BGMEXS.KRT     // Ch 16 - BGMEXS1
SetScale BGMEXS1 p04_scale
SetTotalHitPoints BGMEXS1 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 17 - BGMEXS2  
SetScale BGMEXS2 p05_scale
SetTotalHitPoints BGMEXS2 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 18 - BGMEXS3  
SetScale BGMEXS3 p13_1_scale
SetTotalHitPoints BGMEXS3 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 19 - BGMEXS4  
SetScale BGMEXS4 p04_scale
SetTotalHitPoints BGMEXS4 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 20 - BGMEXS5  
SetScale BGMEXS5 p05_scale
SetTotalHitPoints BGMEXS5 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 21 - BGMEXS6  
SetScale BGMEXS6 p05_scale
SetTotalHitPoints BGMEXS6 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 22 - BGMEXS7  
SetScale BGMEXS7 p21_scale
SetTotalHitPoints BGMEXS7 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 23 - BGMEXS8  
SetScale BGMEXS8 p15_scale
SetTotalHitPoints BGMEXS8 BGMEXS_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BGMIKE.KRT     // Ch 24 - BGMIKE1
SetScale BGMIKE1 p14_scale
SetTotalHitPoints BGMIKE1 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 25 - BGMIKE2  
SetScale BGMIKE2 p10_scale
SetTotalHitPoints BGMIKE2 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 26 - BGMIKE3  
SetScale BGMIKE3 p15_scale
SetTotalHitPoints BGMIKE3 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 27 - BGMIKE4  
SetScale BGMIKE4 p14_scale
SetTotalHitPoints BGMIKE4 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 28 - BGMIKE5  
SetScale BGMIKE5 p14_scale
SetTotalHitPoints BGMIKE5 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 29 - BGMIKE6  
SetScale BGMIKE6 p03_scale
SetTotalHitPoints BGMIKE6 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 30 - BGMIKE7  
SetScale BGMIKE7 p22_scale
SetTotalHitPoints BGMIKE7 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 31 - BGMIKE8  
SetScale BGMIKE8 p20_scale
SetTotalHitPoints BGMIKE8 BGMIKE_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BGSTEV.KRT     // Ch 32 - BGSTEV1
SetScale BGSTEV1 p05_scale
SetTotalHitPoints BGSTEV1 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 33 - BGSTEV2  
SetScale BGSTEV2 p11_scale
SetTotalHitPoints BGSTEV2 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 34 - BGSTEV3  
SetScale BGSTEV3 p10_scale
SetTotalHitPoints BGSTEV3 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 35 - BGSTEV4  
SetScale BGSTEV4 p04_scale
SetTotalHitPoints BGSTEV4 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 36 - BGSTEV5  
SetScale BGSTEV5 p01_scale
SetTotalHitPoints BGSTEV5 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 37 - BGSTEV6  
SetScale BGSTEV6 p04_scale
SetTotalHitPoints BGSTEV6 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 38 - BGSTEV7  
SetScale BGSTEV7 p02_scale
SetTotalHitPoints BGSTEV7 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 39 - BGSTEV8  
SetScale BGSTEV8 p14_scale
SetTotalHitPoints BGSTEV8 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 40 - BGSTEV9  
SetScale BGSTEV9 p15_scale
SetTotalHitPoints BGSTEV9 BGSTEV_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BGTHIN.KRT     // Ch 41 - BGTHIN1
SetScale BGTHIN1 p15_scale
SetTotalHitPoints BGTHIN1 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 42 - BGTHIN2  
SetScale BGTHIN2 p11_scale
SetTotalHitPoints BGTHIN2 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 43 - BGTHIN3  
SetScale BGTHIN3 p12_scale
SetTotalHitPoints BGTHIN3 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 44 - BGTHIN4  
SetScale BGTHIN4 p11_scale
SetTotalHitPoints BGTHIN4 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 45 - BGTHIN5  
SetScale BGTHIN5 p05_scale
SetTotalHitPoints BGTHIN5 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 46 - BGTHIN6  
SetScale BGTHIN6 p02_scale
SetTotalHitPoints BGTHIN6 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 47 - BGTHIN7  
SetScale BGTHIN7 p21_scale
SetTotalHitPoints BGTHIN7 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 48 - BGTHIN8  
SetScale BGTHIN8 p14_scale
SetTotalHitPoints BGTHIN8 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 49 - BGTHIN9  
SetScale BGTHIN9 p21_scale
SetTotalHitPoints BGTHIN9 BGTHIN_hp

LoadKRT \SPRITES\LE2\SALOON\S1\BWANGE.KRT     // Ch 50 - BWANGE1
SetScale BWANGE1 p14_scale
SetTotalHitPoints BWANGE1 BWANGE_hp

LoadKRT \SPRITES\LE2\SALOON\S1\GMRICH.KRT     // Ch 51 - GMRICH1
SetScale GMRICH1 p04_scale
SetTotalHitPoints GMRICH1 GMRICH_hp
ObjectCharacteristics GMRICH1 VICTIM|DISAPPEAR|SCROLL

CloneCharacter GMRICH1                            // Ch 52 - GMRICH2  
SetScale GMRICH2 p01_scale
SetTotalHitPoints GMRICH2 GMRICH_hp
ObjectCharacteristics GMRICH2 VICTIM|DISAPPEAR|SCROLL

LoadKRT \SPRITES\LE2\SALOON\S1\GMSHEL.KRT     // Ch 53 - GMSHEL1
SetScale GMSHEL1 p12_scale
SetTotalHitPoints GMSHEL1 GMSHEL_hp
ObjectCharacteristics GMSHEL1 VICTIM|DISAPPEAR|SCROLL

// Load objects
LoadKRT \SPRITES\LE2\SALOON\S2\SALTROF.KRT           // Ch 54 - TROUGH
ObjectCharacteristics TROUGH  SCROLL|NOKILL

LoadKRT \SPRITES\LE2\SALOON\S2\S5SIGN.KRT            // Ch 55 - SIGN
ObjectCharacteristics SIGN SCROLL|FALL
SetTotalHitPoints SIGN 2

LoadKRT \SPRITES\LE2\SALOON\S1\B2LAMP.KRT            // Ch 56 - LAMP1
ObjectCharacteristics LAMP1 SCROLL
CloneCharacter LAMP1                              // Ch 57 - LAMP2
CloneCharacter LAMP1                              // Ch 58 - LAMP1b
CloneCharacter LAMP1                              // Ch 59 - LAMP2b
SetScale LAMP1  3072
SetScale LAMP2  3072
SetScale LAMP1b 3072
SetScale LAMP2b 3072

LoadKRT \SPRITES\LE2\SALOON\S2\S5PANE.KRT            // Ch 60 - PANE1
ObjectCharacteristics PANE1 SCROLL|WINDOW
CloneCharacter PANE1                              // Ch 61 - PANE2
CloneCharacter PANE1                              // Ch 62 - PANE3
CloneCharacter PANE1                              // Ch 63 - PANE4
CloneCharacter PANE1                              // Ch 64 - PANE5
CloneCharacter PANE1                              // Ch 65 - PANE6
CloneCharacter PANE1                              // Ch 66 - PANE7
CloneCharacter PANE1                              // Ch 67 - PANE8

LoadKRT \SPRITES\LE2\L2GUNS.KRT                   // Ch 68 - CAL50
ObjectCharacteristics CAL50 SCROLL|GUN
CloneCharacter CAL50                              // Ch 69 - TWIN

LoadKRT \SPRITES\LE2\L2NIFE.KRT                   // Ch 70 - KNIFE1
ObjectCharacteristics KNIFE1 SCROLL|DISAPPEAR|THROWN
CloneCharacter KNIFE1                             // Ch 71 - KNIFE2
CloneCharacter KNIFE1                             // Ch 72 - KNIFE3
CloneCharacter KNIFE1                             // Ch 73 - KNIFE4
CloneCharacter KNIFE1                             // Ch 74 - KNIFE5
CloneCharacter KNIFE1                             // Ch 75 - KNIFE6
	
// Projectiles
AssignProjectile BGMEXK1 KNIFE1
AssignProjectile BGMEXK2 KNIFE2
AssignProjectile BGMEXK3 KNIFE3
AssignProjectile BGMEXK4 KNIFE4
AssignProjectile BGMEXK5 KNIFE5
AssignProjectile BGMEXK6 KNIFE6

// Links
Link LAMP1b LAMP1 4 3 0 0 228 104
Link LAMP2b LAMP2 4 3 0 0 345 104

PlayTrack 502 0                 // SD_BGM3

// Place objects
StartActionXY TROUGH    0      472      226       14 0        0 L1
StartActionXY SIGN      0      284       33        7 0        0 L1
StartActionXY CAL50     3      284       33        6 0        0 L1
StartActionXY TWIN      0       90      185        6 0        0 L1
StartActionXY LAMP1     2      228      100        6 0        0 L1
StartActionXY LAMP2     2      345      100        6 0        0 L1
StartActionXY PANE1     0      105       99        4 0        0 L1
StartActionXY PANE2     0      146       99        4 0        0 L1
StartActionXY PANE3     0      105      138        4 0        0 L1
StartActionXY PANE4     0      146      138        4 0        0 L1
StartActionXY PANE5     0      428       99        4 0        0 L1
StartActionXY PANE6     0      470       99        4 0        0 L1
StartActionXY PANE7     0      428      138        4 0        0 L1
StartActionXY PANE8     0      470      138        4 0        0 L1

// Action!
define FC     0  // Frame Counter
StartActionXY BGSTEV1   8    p05_x    p05_y    p05_l FC+64    0 L1  // SIDE
StartActionXY BGMIKE1   5    p14_x    p14_y    p14_l FC+128   0 L5  // SIDE
StartActionXY BGSTEV2   8    p11_x    p11_y    p11_l FC+160   1 L1  // SIDE
StartActionXY BGTHIN1  12    p15_x    p15_y    p15_l FC+192   1 L4  // SIDE
StartActionXY BGMEXS1  12    p04_x    p04_y    p04_l FC+256   1 L1  // SIDE
StartActionXY GMSHEL1   5    p12_x    p12_y    p12_l FC+330   0 L1  // 0x05
StartActionXY BGMIKE2   7    p10_x    p10_y    p10_l FC+384   0 L4  // LOW
StartActionXY BGJACK1  10    p13_x    p13_y    p13_l FC+448   1 L7  // JUMP
StartActionXY BGMIKE3   5    p15_x    p15_y    p15_l FC+512   1 L2  // SIDE
StartActionXY BGJACK2  13    p05_x    p05_y+10 p05_l FC+576   0 L1  // LOW
StartActionXY BGTHIN2  12    p11_x    p11_y    p11_l FC+640   1 L6  // SIDE
StartActionXY BGMEXK1   6    p13_x    p13_y-5  p13_l FC+704   1 L1  // SIDE
StartActionXY GMRICH1   3    p04_x    p04_y    p04_l FC+768   0 L1  // 0x05
StartActionXY BGSTEV3   8    p10_x+5  p10_y-20 p10_l FC+832   0 L6  // SIDE
StartActionXY BGTHIN3  16    p12_x-30 p12_y+10 p12_l FC+896   0 L2  // ROLL
StartActionXY BGMIKE4   5    p14_x    p14_y    p14_l FC+960   0 L1  // SIDE
StartActionXY BGJACK3  13    p11_x    p11_y+25 p11_l FC+1024  1 L3  // LOW
StartActionXY BGMEXK2   6    p10_x+15 p10_y    p10_l FC+1056  0 L1  // SIDE
StartActionXY BGMEXS2  12    p05_x    p05_y-5  p05_l FC+1088  0 L5  // SIDE
StartActionXY BGSTEV4   8    p04_x    p04_y    p04_l FC+1120  1 L7  // SIDE
StartActionXY BGMIKE5   5    p14_x    p14_y    p14_l FC+1152  0 L5  // SIDE
StartActionXY BGMEXS3  16  p13_1_x  p13_1_y  p13_1_l FC+1184  1 L1  // ROLL
StartActionXY BGTHIN4  12    p11_x    p11_y    p11_l FC+1216  1 L3  // SIDE
StartActionXY BGJACK4  13    p12_x+10 p12_y    p12_l FC+1248  0 L1  // LOW
ScrollBKDTo 0 0 0 32 FC+1280

define FC  FC+1280  // Frame Counter
StartActionXY BGJACK5   8    p03_x-5  p03_y    p03_l FC+64    0 L1  // SIDE
StartActionXY BGSTEV5  13    p01_x    p01_y    p01_l FC+128   1 L5  // RUN
StartActionXY BGTHIN5  12    p05_x    p05_y    p05_l FC+192   0 L7  // SIDE
StartActionXY BGMEXS4  12    p04_x    p04_y    p04_l FC+256   1 L5  // SIDE
StartActionXY BGJACK6  13    p02_x    p02_y    p02_l FC+320   0 L1  // LOW
StartActionXY BGMEXK3   6    p03_x    p03_y    p03_l FC+384   0 L4  // SIDE
StartActionXY GMRICH2   3    p01_x    p01_y    p01_l FC+418   0 L1  // 0x05
StartActionXY BGMEXS5  12    p05_x    p05_y-5  p05_l FC+480   0 L6  // SIDE
StartActionXY BGSTEV6   8    p04_x    p04_y    p04_l FC+512   1 L1  // SIDE
StartActionXY BGTHIN6  16    p02_x    p02_y    p02_l FC+576   0 L7  // ROLL
StartActionXY BGMIKE6   5    p03_x    p03_y    p03_l FC+640   0 L1  // SIDE
StartActionXY BGJACK7  10    p01_x    p01_y+5  p01_l FC+704   0 L3  // JUMP
StartActionXY BGMEXS6  12    p05_x    p05_y-5  p05_l FC+736   0 L6  // SIDE
StartActionXY BGMEXK4   6    p04_x-15 p04_y    p04_l FC+768   1 L3  // SIDE
StartActionXY BGSTEV7   8    p02_x    p02_y-15 p02_l FC+800   0 L1  // SIDE
ScrollBKDTo 0 -248 0 62 FC+832

define FC  FC+832  // Frame Counter
StartActionXY BGSTEV8   8    p14_x    p14_y    p14_l FC+32    0 L1  // SIDE
StartActionXY BGTHIN7  16    p21_x    p21_y+10 p21_l FC+34    1 L5  // ROLL
StartActionXY BGJACK8   8    p15_x    p15_y    p15_l FC+128   1 L1  // SIDE
StartActionXY BGMIKE7   5    p22_x    p22_y    p22_l FC+192   1 L3  // SIDE
StartActionXY BGMEXK5   6    p20_x    p20_y    p20_l FC+256   1 L1  // SIDE
StartActionXY BGTHIN8  14    p14_x    p14_y    p14_l FC+288   0 L5  // LOW
StartActionXY BGMEXS7  16    p21_x    p21_y    p21_l FC+320   1 L1  // ROLL
StartActionXY BGSTEV9  10    p15_x    p15_y+10 p15_l FC+384   1 L4  // LOW
StartActionXY BGJACK9   8    p22_x    p22_y    p22_l FC+448   1 L1  // SIDE
StartActionXY BGMIKE8   5    p20_x    p20_y    p20_l FC+480   1 L7  // LOW
StartActionXY BWANGE1   6    p14_x    p14_y    p14_l FC+512   0 L2  // SIDE
StartActionXY BGTHIN9  16    p21_x    p21_y+10 p21_l FC+576   1 L5  // ROLL
StartActionXY BGMEXS8  14    p15_x    p15_y+5  p15_l FC+640   1 L3  // LOW
StartActionXY BGMEXK6   6    p22_x    p22_y+15 p22_l FC+704   1 L7  // SIDE
StartActionXY BGJACK10 13    p20_x    p20_y    p20_l FC+768   1 L1  // LOW
ScrollBKDTo 0 -248 0 0 FC+800

define FC  FC+800  // Frame Counter
EndRound FC+30
